#!/home/joel/Public/src/guile/meta/guile -s
!#
;; first modify the load-path to include modules in subdirectories of
;; CWD
(set! %load-path (cons (getcwd) %load-path))
(use-modules (popgen popgen)
	     (popgen pom)
	     (popgen tlta))
(use-modules (srfi srfi-1)
	     (ice-9 format))
;; tlta model
(define *step* -0.05)			;this must be negative
(define *initval* (+ 1.0 *step*))
(define *numpoints* 18)

;; set some global parameters
(set! *every* 1000)
  
;; this may call for a macro
(define (tlta-inits p1init p2init D)
  (map (lambda (x)
	 (list->vector (reverse (cons D x))))
       `(,@(zip (iota *numpoints* p1init *step*)
		(make-list *numpoints* p2init))
	 ,@(zip (make-list *numpoints* p1init)
		(iota *numpoints* p2init *step*)))))

;; ;; tlta model
(with-output-to-file "tlta.out"
  (lambda ()
    (sim-control tltafun (tlta-inits *initval* *initval* 0.0))))

;; (trace sim-control pomfun format)
;; costly female choice model
(with-output-to-file "pom.out"
  (lambda ()
    (sim-control pomfun 
		 (map (lambda (lst)
			(list->vector lst))
		      (zip (make-list 10 0.1)
			   (iota 10 0.0 0.1)
			   (make-list 10 0.0))))))
